from pathlib import Path
from skyrim_tools.lib.plugin import ElderScrollsFile



# mod_path = Path("D:/Mods/MO2-SSE/mods/SPIDER - test/new_test.esp")
mod_path = Path("D:/Mods/MO2-SSE/mods/SPIDER - test/new_test2.esp")
def _get_str(content: bytes, encoding='utf-8') -> "str|None":
    for encoding in ['utf-8', 'windows-1252']:
        try:
            return content.decode(encoding).strip('\0')
        except UnicodeDecodeError:
            pass

def _get_int(content: bytes) -> int:
    return int.from_bytes(content, 'little', signed=False)

with ElderScrollsFile(file_path=mod_path) as plugin:
    print(plugin)
    print("*************************************")
    #records = [r for r in plugin._get_all_records()]
    records = plugin._get_all_records()
    # print(records)
    print(list(records))
    print("*************************************")
    print(plugin.header_record)
print("*************************************")
with open(mod_path, 'rb') as f:
    content = f.read()
    print(content)
print("*************************************")
# résultat attendu:
#   Masters = Silt_Strider_Armor_Ultimate_by_Aewin.esl + Wind_Ruler_Armor_Ultimate_by_Aewin.esp + Skyrim.esm + Update.esm + Dragonborn.esm +/- Dawnguard.esm (+/- Hearthfire...)
# OTFT = 0x800 / testOtft, listant FE000801 & FE001807
# b = b"\x1d\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x05\x00\x00\x00\x00,\x00\x00\x00"
# b = b"\x08\x00\x01\x08\x00\x03\x07\x08\x00\x04"
# b = b"\x01\x08\x00\x00"
# b = b"\xd9?\x02\x00\x00"
b = b"\x02\x00\x00\x00"
c = b"CNAM\x01\x00\x00MAST\x0b\x00Skyrim.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0b\x00Update.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0f\x00Dragonborn.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST)\x00Silt_Strider_Armor_Ultimate_by_Aewin.esl\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST'\x00Wind_Ruler_Armor_Ultimate_by_Aewin.esp\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00GRUPM\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00OTFT\x1d\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x05\x00\x00\x00\x00,\x00\x00\x00EDID\t\x00testOtft\x00INAM\x08\x00\x01\x08\x00\x03\x07\x08\x00\x04"
full = b"TES4\xf2\x00\x00\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00,\x00\x00\x00HEDR\x0c\x00\x9a\x99\xd9?\x02\x00\x00\x00\x01\x08\x00\x00CNAM\x01\x00\x00MAST\x0b\x00Skyrim.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0b\x00Update.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0f\x00Dragonborn.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST)\x00Silt_Strider_Armor_Ultimate_by_Aewin.esl\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST'\x00Wind_Ruler_Armor_Ultimate_by_Aewin.esp\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00GRUPM\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00OTFT\x1d\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x05\x00\x00\x00\x00,\x00\x00\x00EDID\t\x00testOtft\x00INAM\x08\x00\x01\x08\x00\x03\x07\x08\x00\x04"
full2 = b"TES4\xf2\x00\x00\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00,\x00\x00\x00HEDR\x0c\x00\x9a\x99\xd9?\x02\x00\x00\x00\x01\x08\x00\x00CNAM\x01\x00\x00MAST\x0b\x00Skyrim.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0b\x00Update.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST\x0f\x00Dragonborn.esm\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST)\x00Silt_Strider_Armor_Ultimate_by_Aewin.esl\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00MAST'\x00Wind_Ruler_Armor_Ultimate_by_Aewin.esp\x00DATA\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00GRUPQ\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00OTFT!\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x05\x00\x00\x00\x00,\x00\x00\x00EDID\t\x00testOtft\x00INAM\x0c\x00\x01\x08\x00\x03\x07\x08\x00\x04\x02\x08\x00\x03"

print(len(c))
# size devrait etre 242 ?

# print(b.decode('utf-8'))
# print(b.decode('ascii'))
# print(_get_str(b))
# print(_get_int(b))
# print(_get_int(b"'\x00"))
# print(_get_int(b"\x1d"))
# print(_get_int(b"!"))
# print(_get_int(b"INAM\x08\x00\x01\x08\x00\x03\x07\x08\x00\x04"))
# print(_get_int(b"\x08\x00\x01\x08\x00\x03\x07\x08\x00\x04"))
# print(_get_int(b"INAM\x0c\x00\x01\x08\x00\x03\x07\x08\x00\x04\x02\x08\x00\x03"))
# print(_get_int(b"\x0c\x00\x01\x08\x00\x03\x07\x08\x00\x04\x02\x08\x00\x03"))
# print(_get_int(b"\x0c"))
# print(_get_int(b"\x02\x08\x00\x03"))
# print(_get_int(b"Q\x00\x00\x00"))
# print(_get_int(b"M\x00\x00\x00"))
# print(_get_int(b"M"))
# print(_get_int(b"\x02\x08\x00\x03"))
# print(_get_str(b"INAM"))


### Co-ouvrir fichier "compréhension" et tesv/core pour comprendre et tester les fichiers new_file.esp et new_file2.esp...
# header_size
print(len(b"GRUPM\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"))
# type
print(b"GRUPM\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"[12:16])
print(b"GRUPQ\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"[12:16])
# label (for type 0)
print(b"GRUPM\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"[8:12].decode('ascii'))
print(b"GRUPQ\x00\x00\x00OTFT\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"[8:12].decode('ascii'))
